#include "bits/stdc++.h"

using namespace std;
#define int long long
#define all(a)a.begin(),a.end()
#define sz(a)(int)a.size()

struct P {
    int x, y, i;

    P() {};

    P(int x, int y, int i) : x(x), y(y), i(i) {};

    P f(P other) {
        P p;
        p.x = other.x - x;
        p.y = other.y - y;
        p.i = i;
        return p;
    }
};

int n, t;
vector<P> pos;

int v(P a, P b) {
    return a.x * b.y - a.y * b.x;
}

int len2(P a) {
    return a.x * a.x + a.y * a.y;
}

void solve() {
    cin >> n >> t;
    if (n == 1) {
        cout << "R\n";
        return;
    }
    pos.assign(n, {});
    for (int i = 0; i < n; ++i) {
        cin >> pos[i].x >> pos[i].y;
        pos[i].i = i;
    }
    sort(all(pos), [&](P a, P b) {
        return make_pair(a.x, a.y) < make_pair(b.x, b.y);
    });
    for (int i = 1; i + 1 < n; ++i) {
        if (v(pos[i].f(pos[i - 1]), pos[i].f(pos[i + 1])) != 0) {
            for (int j = 0; j < n; ++j)
                cout << "G";
            return;
        }
    }
    vector<vector<int>> g(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i != j) {
                if (i < j) {
                    int k = j + t;
                    if (k >= n) {
                        int d = k - n + 1;
                        k = j - d;
                    }
                    g[i][j] = k;
                } else {
                    int k = j - t;
                    if (k < 0) {
                        int d = -k;
                        k = j + d;
                    }
                    g[i][j] = k;
                }
            }
        }
    }
    string clr(n, 'R');
    vector<vector<int>> used(n, vector<int>(n));
    vector<int> tin(n, 0);
    int TIME = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i != j) {
                int u = i;
                int v = j;
                int REM = TIME;
                while (used[u][v] < REM) {
                    used[u][v] = TIME;
                    tin[u] = TIME;
                    int w = g[u][v];
                    u = v;
                    v = w;
                    ++TIME;
                }
                if (used[u][v] <= tin[i])
                    clr[i] = 'G';
                break;
            }
        }
    }
    string ans(n, 'R');
    for (int i = 0; i < n; ++i)
        ans[pos[i].i] = clr[i];
    cout << ans << "\n";
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
//    cin >> _;
    while (_--)
        solve();
    return 0;
}
