#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
const int inf = 1e5 + 1;
const int mod = 1e9 + 7;
const int R = 1 << 17;
vector<int> sg(2 * R);

int get(int x, int xl, int xr, int ql, int qr) {
    if (qr <= xl || xr <= ql)
        return -inf;
    if (ql <= xl && xr <= qr)
        return sg[x];
    int mid = (xl + xr) >> 1;
    return max(get(x * 2, xl, mid, ql, qr), get(x * 2 + 1, mid, xr, ql, qr));
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n + 2, inf);
    vector<int> pos(1e5 + 2);
    pos[1e5 + 1] = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i + 1];
        sg[R + i + 1] = a[i + 1];
    }
    for (int i = R - 1; i > 0; --i)
        sg[i] = max(sg[i * 2], sg[i * 2 + 1]);
    vector<int> ans(q);
    vector<vector<pair<int, int>>> Q(n + 1);
    for (int i = 0; i < q; ++i) {
        int pi, ki;
        cin >> pi >> ki;
        if (ki == 1) {
            ans[i] = 1;
        } else {
            Q[a[pi]].emplace_back(ki, i);
        }
    }
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) 
            pos[a[i + 1]] = i + 1;
        for (int j = 1; j <= n; ++j) {
            for (auto [k, ind]: Q[a[j]]) {
                if (k + j - 1 > n)
                    continue;
                int l = j;
                int r = k + j;
                int x = a[l];
                int C = a[r];
                if (x > C)
                    continue;
                int M = get(1, 0, R, l + 1, r);
                if (M < x) {
                    ans[ind] += k - 1;
                } else {
                    int m = max(get(1, 0, R, l + 1, pos[M]), get(1, 0, R, pos[M] + 1, r));
                    if (x < M && M < C) {
                        ans[ind] += (r - 1) - pos[M];
                        if (x > m || pos[m] < pos[M])
                            ans[ind]++;
                    } else {
                        if (x > m || pos[m] < pos[M])
                            ans[ind]++;
                    }
                }
            }
        }
        reverse(all(a));
    }
    for (auto x: ans)
        cout << x << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}