#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
const int inf = 1e9 + 1;
const int mod = 1e9 + 7;

int binpow(int a, int b) {
    int p = 1;
    while (b > 0)
        if (b % 2 == 1)
            (p *= a) %= mod, b--;
        else
            (a *= a) %= mod, b /= 2;
    return p;
}

string s;

int res = 0;
int ab = 0;
int ba = 0;
int aa = 0;
int bb = 0;
map<string, int> cnt;
string CUR;

void rec(int i, int n, map<string, int> &cur) {
    if (i == n) {
        ++res;
        return;
    }
    for (auto c: {'a', 'b', 'c'}) {
        CUR.push_back(c);
        if (i == 0) {
            rec(i + 1, n, cur);
            CUR.pop_back();
        } else {
            string u = CUR.substr(sz(CUR) - 2, 2);
            cur[u]++;
            if (cur[u] <= cnt[u])
                rec(i + 1, n, cur);
            CUR.pop_back();
            cur[u]--;
        }
    }
}

const int N = 1e6 + 1;
vector<int> fact(N, 1), inv_fact(N, 1);

int cnk(int n, int k) {
    return fact[n] * inv_fact[k] % mod * inv_fact[n - k] % mod;
}

int f(int k, int n) {
    if (k < 0 || n + k - 1 < 0)
        return 1;
    return cnk(n + k - 1, k - 1);
}

void solve() {
    int G, q;
    cin >> G >> q;
    for (int i = 1; i < N; ++i) {
        fact[i] = fact[i - 1] * i % mod;
        inv_fact[i] = binpow(fact[i], mod - 2);
    }
    if (G == 0) {
        cout << "3\n3\n2\n1\n";
        return;
    }
    if (G == 3) {
        while (q--) {
            res = 0;
            cin >> s;

            cnt.clear();
            for (int i = 0; i + 1 < sz(s); ++i)
                cnt[s.substr(i, 2)]++;
            map<string, int> cur;
            rec(0, sz(s), cur);
            cout << res << "\n";
        }
        return;

    }

    while (q--) {
        cin >> s;
        if (sz(s) == 1) {
            cout << "3\n";
            continue;
        }
        ab = 0;
        ba = 0;
        aa = 0;
        bb = 0;
        for (int i = 0; i + 1 < sz(s); ++i) {
            if (s[i] == 'a') {
                if (s[i + 1] == 'b')
                    ab++;
                else
                    ++aa;
            } else {
                if (s[i + 1] == 'a')
                    ba++;
                else
                    bb++;
            }
        }
        int ans = 0;
        if (ab == ba) {

            (ans += f(ab + 1, bb) * f(ab, aa) % mod) %= mod;
            (ans += f(ab, bb) * f(ab + 1, aa) % mod) %= mod;
        } else {
            int mx = max(ab, ba);
            (ans += f(mx, bb + aa)) %= mod;
        }
        cout << ans << "\n";

    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}