#include "bits/stdc++.h"

using namespace std;
#define int long long
#define all(a)a.begin(),a.end()
#define sz(a)(int)a.size()

struct P {
    int x, y, i;

    P() {};

    P(int x, int y, int i) : x(x), y(y), i(i) {};

    P f(P other) {
        P p;
        p.x = other.x - x;
        p.y = other.y - y;
        p.i = i;
        return p;
    }
};

int n, t;
vector<P> pos;

int v(P a, P b) {
    return a.x * b.y - a.y * b.x;
}

int len2(P a) {
    return a.x * a.x + a.y * a.y;
}

int eq(P a, P b) {
    return make_pair(a.x, a.y) == make_pair(b.x, b.y);
}

void solve() {
    cin >> n >> t;
    if (n == 1) {
        cout << "R\n";
        return;
    }
    pos.assign(n, {});
    for (int i = 0; i < n; ++i) {
        cin >> pos[i].x >> pos[i].y;
        pos[i].i = i;
    }

    sort(all(pos), [&](P a, P b) {
        return make_pair(a.x, a.y) < make_pair(b.x, b.y);
    });
    for (int T = 1; T + 1 < n; ++T) {
        if (v(pos[T].f(pos[T - 1]), pos[T].f(pos[T + 1])) != 0) {
//            for (int j = 0; j < n; ++j)
//                cout << "G";
            vector<vector<int>> g(n, vector<int>(n));
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (i != j) {
                        vector<int> vers;
                        P vect = P(pos[j].x - pos[i].x, pos[j].y - pos[i].y, -1);
                        for (int k = 0; k < n; ++k)
                            if (k != j)
                                vers.push_back(k);
                        sort(all(vers), [&](int a, int b) {
                            P p1 = pos[a];
                            p1.x -= pos[j].x;
                            p1.y -= pos[j].y;
                            P p2 = pos[b];
                            p2.x -= pos[j].x;
                            p2.y -= pos[j].y;
                            int v1 = v(vect, p1);
                            int v2 = v(vect, p2);
                            if (v1 * v2 != 0) {
                                if (v1 * v2 < 0)
                                    return v1 > v2;
                                if (v(p1, p2) == 0)
                                    return len2(p1) < len2(p2);
                                if (v1 * v2 > 0)
                                    return v(vect, p1) == v(p1, p2);
                                return v(vect, p2) == v(p2, p1);
                            } else {
                                P mv1 = p1;
                                int d = __gcd(p1.x, p1.y);
                                mv1.x = mv1.x / d;
                                mv1.y = mv1.y / d;

                                P mv2 = p2;
                                d = __gcd(p2.x, p2.y);
                                mv2.x = mv2.x / d;
                                mv2.y = mv2.y / d;
                                d = __gcd(vect.x, vect.y);
                                vect.x = vect.x / d;
                                vect.y = vect.y / d;
                                if (v1 == 0 && v2 == 0) {
                                    if (eq(mv1, vect) && !eq(mv2, vect))
                                        return true;
                                    if (!eq(mv1, vect) && eq(mv2, vect))
                                        return false;
                                    return len2(p1) < len2(p2);
                                } else {
                                    if (v1 == 0) {
                                        if (eq(mv1, vect))
                                            return true;
                                        if (v2 > 0)
                                            return false;
                                        return true;
                                    } else {
                                        if (eq(mv2, vect))
                                            return false;
                                        if (v1 > 0)
                                            return true;
                                        return false;
                                    }
                                }
                            }
                        });
//                        cout << i + 1 << " " << j + 1 << " " << vers[0] + 1 << endl;
                        g[i][j] = vers[t - 1];
                    }
                }
            }
            string clr(n, 'R');
            vector<vector<int>> used(n, vector<int>(n));
            vector<int> tin(n, 0);
            int TIME = 1;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (i != j) {
                        int u = i;
                        int v = j;
                        ++TIME;
                        int REM = TIME;
                        while (used[u][v] < REM) {
                            used[u][v] = TIME;
                            tin[u] = TIME;
                            int w = g[u][v];
                            u = v;
                            v = w;
                            ++TIME;
                        }
                        if (used[u][v] <= tin[i]) {
                            clr[i] = 'G';
                            break;
                        } else {
                            if (tin[i] > REM)
                                clr[i] = 'B';
                        }
                    }
                }
            }
            string ans(n, 'R');
            for (int i = 0; i < n; ++i)
                ans[pos[i].i] = clr[i];
            cout << ans << "\n";
            return;
        }
    }
    vector<vector<int>> g(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i != j) {
                if (i < j) {
                    int k = j + t;
                    if (k >= n) {
                        int d = k - n + 1;
                        k = j - d;
                    }
                    g[i][j] = k;
                } else {
                    int k = j - t;
                    if (k < 0) {
                        int d = -k;
                        k = j + d;
                    }
                    g[i][j] = k;
                }
            }
        }
    }
    string clr(n, 'R');
    vector<vector<int>> used(n, vector<int>(n));
    vector<int> tin(n, 0);
    int TIME = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i != j) {
                int u = i;
                int v = j;
                int REM = TIME;
                while (used[u][v] < REM) {
                    used[u][v] = TIME;
                    tin[u] = TIME;
                    int w = g[u][v];
                    u = v;
                    v = w;
                    ++TIME;
                }
                if (used[u][v] <= tin[i])
                    clr[i] = 'G';
                break;
            }
        }
    }
    string ans(n, 'R');
    for (int i = 0; i < n; ++i)
        ans[pos[i].i] = clr[i];
    cout << ans << "\n";
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
//    cin >> _;
    while (_--)
        solve();
    return 0;
}
