#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
const int inf = 1e9 + 1;
const int mod = 1e9 + 7;

int binpow(int a, int b) {
    int p = 1;
    while (b > 0)
        if (b & 1)
            (p *= a) %= mod, b--;
        else
            (a *= a) %= mod, b >>= 1;
    return p;
}


void solve() {
    int G, q;
    cin >> G >> q;
    if (G == 0) {
        cout << "3\n3\n2\n1\n";
        return;
    }
    while (q--) {
        string s;
        cin >> s;
        map<string, int> cnt;
        for (int i = 0; i + 1 < sz(s); ++i) {
            cnt[s.substr(i, 2)]++;
        }
        int ab = cnt["ab"];
        int bb = cnt["bb"];
        int ba = cnt["ba"];
        int aa = cnt["aa"];
        int ans = 0;
        if (ab == ba) {
            (ans += binpow(ab + 1, bb) * binpow(ab, aa) % mod) %= mod;
            (ans += binpow(ab, bb) * binpow(ab + 1, aa) % mod) %= mod;
        } else {
            int mx = max(ab, ba);
            (ans += binpow(mx, bb + aa)) %= mod;
        }
        cout << ans << "\n";

    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}